apiVersion: apiextensions.k8s.io/v1
kind: CustomResourceDefinition
metadata:
  annotations:
    controller-gen.kubebuilder.io/version: v0.17.3
  labels:
    external-secrets.io/component: controller
  name: passwords.generators.external-secrets.io
spec:
  group: generators.external-secrets.io
  names:
    categories:
    - external-secrets
    - external-secrets-generators
    kind: Password
    listKind: PasswordList
    plural: passwords
    singular: password
  scope: Namespaced
  versions:
  - name: v1alpha1
    schema:
      openAPIV3Schema:
        description: |-
          Password generates a random password based on the
          configuration parameters in spec.
          You can specify the length, characterset and other attributes.
        properties:
          apiVersion:
            description: |-
              APIVersion defines the versioned schema of this representation of an object.
              Servers should convert recognized schemas to the latest internal value, and
              may reject unrecognized values.
              More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#resources
            type: string
          kind:
            description: |-
              Kind is a string value representing the REST resource this object represents.
              Servers may infer this from the endpoint the client submits requests to.
              Cannot be updated.
              In CamelCase.
              More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds
            type: string
          metadata:
            type: object
          spec:
            description: PasswordSpec controls the behavior of the password generator.
            properties:
              allowRepeat:
                default: false
                description: set AllowRepeat to true to allow repeating characters.
                type: boolean
              digits:
                description: |-
                  Digits specifies the number of digits in the generated
                  password. If omitted it defaults to 25% of the length of the password
                type: integer
              length:
                default: 24
                description: |-
                  Length of the password to be generated.
                  Defaults to 24
                type: integer
              noUpper:
                default: false
                description: Set NoUpper to disable uppercase characters
                type: boolean
              symbolCharacters:
                description: |-
                  SymbolCharacters specifies the special characters that should be used
                  in the generated password.
                type: string
              symbols:
                description: |-
                  Symbols specifies the number of symbol characters in the generated
                  password. If omitted it defaults to 25% of the length of the password
                type: integer
            required:
            - allowRepeat
            - length
            - noUpper
            type: object
        type: object
    served: true
    storage: true
    subresources:
      status: {}
